#!/bin/sh
# allocate resources for SCHED_RT to the test processes on systems
# using CONFIG_RT_GROUP_SCHED 
# (see https://lsbbugs.linuxfoundation.org/show_bug.cgi?id=3116)

ACCT_DIR=/sys/fs/cgroup/cpu,cpuacct
LSB_ALLOC=200000
LSB_GROUP=lsb-test

if [ -d "$ACCT_DIR" ];then
  echo "Allocating SCHED_RT access for the test suite..."
  if [ ! -d "$ACCT_DIR/$LSB_GROUP" ];then
    mkdir "$ACCT_DIR/$LSB_GROUP"
  fi
  if [ -f "$ACCT_DIR/$LSB_GROUP/cpu.rt_runtime_us" ];then
    LSB_SET_ALLOC=`cat "$ACCT_DIR/$LSB_GROUP/cpu.rt_runtime_us"`
  fi
  if [ ! -f "$ACCT_DIR/$LSB_GROUP/cpu.rt_runtime_us" -o "$LSB_SET_ALLOC" -lt "$LSB_ALLOC" ];then
    ROOT_ALLOC=`cat "$ACCT_DIR/cpu.rt_runtime_us"`
    NEW_ALLOC=`expr $ROOT_ALLOC - $LSB_ALLOC`
    if [ "$NEW_ALLOC" -gt 0 ];then
      /bin/echo $NEW_ALLOC > "$ACCT_DIR/cpu.rt_runtime_us"
      /bin/echo $LSB_ALLOC > "$ACCT_DIR/$LSB_GROUP/cpu.rt_runtime_us"
    else
      echo "Unable to determine new value for SCHED_RT for root..."
    fi
  else
    echo "Access to SCHED_RT appears to already be setup..."
  fi
  if [ -d "$ACCT_DIR/$LSB_GROUP" ];then
    touch "$ACCT_DIR/$LSB_GROUP/tasks"
    chmod 0666 "$ACCT_DIR/$LSB_GROUP/tasks"
  fi
else
  echo "cgroups do not seem to be enabled on this system, skipping..."
fi
