#!/bin/sh

# Program expects file argument as first parameter to
# append parameterisations information into 

set_init_path() {
  if [ -d /etc/rc.d/rc0.d ] && [ -d /etc/rc.d ] && [ ! -L /etc/rc.d ]; then
    # RH/Fedora/Mandriva
    init_parent="/etc/rc.d"
  elif [ -d /etc/rc0.d ]; then
    # Debian derivatives
    init_parent="/etc"
  else
    # SLES and the original default
    init_parent="/etc/init.d"
  fi
}

if test $# -lt 1
then
  echo "Parameterisations file needs file argument."
  exit 1
fi

# bug 4108: flip default to no. Many systems now are systemd;
# need to explicitly select if you want the sysv style
echo "LSB_INITD_SCRIPTS_DIR=$HOME/scripts/initd" >> $1

printf "Does the implementation provide a System V Init mechanism..? [n] "
read cmd
if [ "$cmd" = "N" -o "$cmd" = "n" -o "$cmd" = "" ] ; then
        echo "LSB_INITD_SYSV_INIT=\"\"" >> $1
else
        echo "LSB_INITD_SYSV_INIT=true" >> $1
fi

set_init_path
printf "Enter the pathname for the parent directory for the rc.d directories... [%s] " $init_parent
read cmd
if [ "$cmd" = "" ] ; then
	echo "LSB_INITD_RC_PARENT_DIR=$init_parent" >> $1
else
	echo "LSB_INITD_RC_PARENT_DIR=$cmd" >> $1
fi
